//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////
#include <math.h>
#include "IVector2Util.h"

int IVector2Util::getXLength( IVector2& pos1, IVector2& pos2 )
{
	return abs( (pos1.x - pos2.x) );
}
	
int IVector2Util::getYLength( IVector2& pos1, IVector2& pos2 )
{
	return abs( (pos1.y - pos2.y) );
}

IVector2 IVector2Util::ConvertVecByDownSide( IVector2& pos, IVector2& center, TYPE_SIDE side )
{
	//高速化のため行列を使わず変換

	IVector2 temp = pos - center;
	IVector2 ret = temp;
	switch( side )
	{
	case UP_SIDE:
		ret.x = -temp.x;
		ret.y = -temp.y;
		break;
	case RIGHT_SIDE:
		ret.x = -temp.y;
		ret.y = temp.x;
		break;
	case DOWN_SIDE:
		break;
	case LEFT_SIDE:
		ret.x = temp.y;
		ret.y = -temp.x;
		break;
	}
	ret = ret + center;
	return ret;
}

IVector2 IVector2Util::ConvertMirror( IVector2& pos, IVector2& center, TYPE_MIRROR mirror )
{
	// 高速化のため行列を使わず変換

	IVector2 temp = pos - center;
	IVector2 ret  = temp;

	switch( mirror )
	{
	case NONE_MIRROR:
		break;
	case X_MIRROR:
		ret.x = -temp.x;
		break;
	case Y_MIRROR:
		ret.y = -temp.y;
		break;
	case XY_MIRROR:
		ret.x = -temp.x;
		ret.y = -temp.y;
		break;
	}
	ret = ret + center;
	return ret;
}