//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////
#pragma once
#include "PatternBase.h"
#include "PatternPrimitive.h"

#include "../IgoTypes.h"

namespace pattern
{
class PatternFirst : public PatternBase
{
public:
	virtual void setup()
	{
		pushBack(  PatternPrimitive( STONE_WHITE, 0, 0 ) );
		pushBack(  PatternPrimitive( STONE_NONE,  0, 1 ) );
		pushBack(  PatternPrimitive( STONE_NONE,  0, 2 ) );		
		setAnswer( PatternPrimitive( STONE_BLACK, 0, 2 ) );
		// 三線より上
		setLowLine( 2 );
	}
	// パターン検索
	virtual std::vector< PatternPrimitive > matchPoint( int attr, PatternPrimitive* state, int count, Aspect* aspect )
	{
		std::vector< PatternPrimitive > ret;
		if( count == 0 )
		{
			ret.push_back( PatternPrimitive( attr, 4, 3 ) );
		}
		else //if( count == 1 )
		{
			ret = PatternBase::matchPoint( attr, state, count, aspect );
		}

		return ret;
	}
private:
};

}