//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#include "PatternManager.h"


namespace pattern
{
PatternManager& PatternManager::getSingleton()
{
	static PatternManager manager_;
	return manager_;
}

void PatternManager::initialzie()
{
	clear();
	first_.setup();
	pattern_[ IKKEN ]       = &ikken_;
	pattern_[ YOSE_KOSUMI ] = &yoseKosumi_;
	pattern_[ KEIMA ]       = &keima_;
	pattern_[ OSAE  ]       = &osae_;
	pattern_[ SUBERI ]      = &suberi_;
	pattern_[ HANE ]        = &hane_;
	pattern_[ NIGE ]        = &nige_;

	for( int i = 0; i < PATTERN_COUNT; i++ )
	{
		pattern_[i]->setup();
	}
}
void PatternManager::push( STONE_COLOR color, int x, int y )
{
	primitive_[primitiveCount_] = pattern::PatternPrimitive( color, x, y );
	primitiveCount_++;
	aspectBoard_.attr[x][y] = color;


}
PatternPrimitive PatternManager::getNext( int attr )
{

	if( primitiveCount_ < 2 )
	{
		std::vector< PatternPrimitive > ret = first_.matchPoint( attr, primitive_, primitiveCount_, &aspectBoard_ );
		std::vector< PatternPrimitive >::iterator iter = ret.begin();
		std::vector< PatternPrimitive >::iterator end  = ret.end();
		while( iter != end )
		{
			if( (*iter).position.x > 2 && (*iter).position.x < 6 )
			{
				return (*iter);
			}
			iter++;
		}
		return *ret.begin();
	}

	// とりあえず組み立てずに、順番に調べる
	for( int i = 0; i < PATTERN_COUNT; i++ )
	{
		std::vector< PatternPrimitive > ret = pattern_[i]->matchPoint( attr, primitive_, primitiveCount_, &aspectBoard_ );
		if( ret.size() != 0 )
		{
			return *ret.begin();
		}
	}

	return PatternPrimitive( attr, -1, -1 );
}

}
