//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#pragma once

#include <vector>

namespace util
{

template <class T, class R>
class DataNode
{
public:
	DataNode( T& data )
	{
		data_ = new T( data );
		next_ = new std::vector<DataNode*>( 5 );
	}

	~DataNode()
	{
		delete (data_);
		delete (next_);
	}

	T&   getData()
	{
		return (*data_);
	}

	void setNext( DataNode* node )
	{
		next_->push_back( node );
	}
	

	DataNode* matchNext( T& value, R& head )
	{
		std::vector<DataNode*>::iterator iter  = next_->begin();
		std::vector<DataNode*>::iterator end   = next_->end();
		for(;;)
		{

			if( iter == end )break;
			if( (*iter) == NULL ) break;

			if( (*iter)->getData().match( value, head ) == true )
			{
				return (*iter);
			}
			
			iter++;
		}
		return NULL;
	}

private:
	T* data_;
	std::vector<DataNode*>* next_;
};

}

